Index: src/newlib/libc/stdio64/freopen64.c
diff -u src/newlib/libc/stdio64/freopen64.c:1.6 src/newlib/libc/stdio64/freopen64.c:1.7
--- src/newlib/libc/stdio64/freopen64.c:1.6	Thu Sep 16 21:18:50 2004
+++ src/newlib/libc/stdio64/freopen64.c	Tue Feb  8 01:33:17 2005
@@ -91,9 +91,9 @@
 
   __sfp_lock_acquire ();
 
-  _flockfile(fp);
+  CHECK_INIT (ptr);
 
-  CHECK_INIT (fp);
+  _flockfile(fp);
 
   if ((flags = __sflags (ptr, mode, &oflags)) == 0)
     {
Index: src/newlib/libc/stdio64/fseeko64.c
diff -u src/newlib/libc/stdio64/fseeko64.c:1.5 src/newlib/libc/stdio64/fseeko64.c:1.6
--- src/newlib/libc/stdio64/fseeko64.c:1.5	Tue Aug 26 18:09:43 2003
+++ src/newlib/libc/stdio64/fseeko64.c	Tue Feb  8 01:33:17 2005
@@ -111,11 +111,11 @@
   struct stat64 st;
   int havepos;
 
-  _flockfile(fp);
-
   /* Make sure stdio is set up.  */
 
-  CHECK_INIT (fp);
+  CHECK_INIT (ptr);
+
+  _flockfile(fp);
 
   curoff = fp->_offset;
 
Index: src/newlib/libc/stdio64/ftello64.c
diff -u src/newlib/libc/stdio64/ftello64.c:1.3 src/newlib/libc/stdio64/ftello64.c:1.4
--- src/newlib/libc/stdio64/ftello64.c:1.3	Fri Aug 22 18:52:25 2003
+++ src/newlib/libc/stdio64/ftello64.c	Tue Feb  8 01:33:17 2005
@@ -91,11 +91,11 @@
 {
   _fpos64_t pos;
 
-  _flockfile(fp);
-
   /* Ensure stdio is set up.  */
 
-  CHECK_INIT (fp);
+  CHECK_INIT (ptr);
+
+  _flockfile(fp);
 
   if (fp->_seek64 == NULL)
     {
Index: src/newlib/libc/stdlib/mallocr.c
diff -u src/newlib/libc/stdlib/mallocr.c:1.12 src/newlib/libc/stdlib/mallocr.c:1.13
--- src/newlib/libc/stdlib/mallocr.c:1.12	Tue Aug 19 18:09:54 2003
+++ src/newlib/libc/stdlib/mallocr.c	Tue Feb  8 01:33:17 2005
@@ -3484,7 +3484,7 @@
   MALLOC_UNLOCK;
 
 #ifdef INTERNAL_NEWLIB
-  _REENT_SMALL_CHECK_INIT(_stderr_r (reent_ptr));
+  _REENT_SMALL_CHECK_INIT(reent_ptr);
   fp = _stderr_r(reent_ptr);
 #define fprintf fiprintf
 #else
Index: src/newlib/libc/stdlib/mstats.c
diff -u src/newlib/libc/stdlib/mstats.c:1.4 src/newlib/libc/stdlib/mstats.c:1.5
--- src/newlib/libc/stdlib/mstats.c:1.4	Fri Sep  5 00:13:15 2003
+++ src/newlib/libc/stdlib/mstats.c	Tue Feb  8 01:33:19 2005
@@ -140,7 +140,7 @@
 	struct _reent *ptr _AND
 	char *s)
 {
-  _REENT_SMALL_CHECK_INIT(_stderr_r (ptr));
+  _REENT_SMALL_CHECK_INIT(ptr);
   fiprintf (_stderr_r (ptr), "Memory allocation statistics %s\n", s);
   _malloc_stats_r (ptr);
 }
Index: src/newlib/libc/stdlib/setenv_r.c
diff -u src/newlib/libc/stdlib/setenv_r.c:1.5 src/newlib/libc/stdlib/setenv_r.c:1.6
--- src/newlib/libc/stdlib/setenv_r.c:1.5	Wed Apr 17 21:23:30 2002
+++ src/newlib/libc/stdlib/setenv_r.c	Thu Jan 20 17:31:04 2005
@@ -122,7 +122,7 @@
   ENV_UNLOCK;
 
   /* if we are setting the TZ environment variable, update timezone info */
-  if (strcmp (name, "TZ") == 0)
+  if (strncmp ((*p_environ)[offset], "TZ=", 3) == 0)
     tzset ();
 
   return 0;
Index: src/newlib/libc/stdlib/strtod.c
diff -u src/newlib/libc/stdlib/strtod.c:1.4 src/newlib/libc/stdlib/strtod.c:1.6
--- src/newlib/libc/stdlib/strtod.c:1.4	Fri Dec  6 18:58:51 2002
+++ src/newlib/libc/stdlib/strtod.c	Fri Apr  1 09:54:19 2005
@@ -111,15 +111,16 @@
   int bb2, bb5, bbe, bd2, bd5, bbbits, bs2, c, dsign, e1, esign, i, j,
     k, nd, nd0, nf, nz, nz0, sign;
   long e;
-  _CONST char *s, *s0, *s1;
+  _CONST char *s, *s0, *s1, *s2;
   double aadj, aadj1, adj;
   long L;
   unsigned long z;
   __ULong y;
   union double_union rv, rv0;
+  int nanflag;
 
   _Bigint *bb, *bb1, *bd, *bd0, *bs, *delta;
-  sign = nz0 = nz = 0;
+  sign = nz0 = nz = nanflag = 0;
   rv.d = 0.;
   for (s = s00;; s++)
     switch (*s)
@@ -145,7 +146,23 @@
 	goto break2;
       }
 break2:
-  if (*s == '0')
+  if (*s == 'n' || *s == 'N')
+    {
+      ++s; 
+      if (*s == 'a' || *s == 'A')
+        {
+          ++s;
+          if (*s == 'n' || *s == 'N')
+            {
+              nanflag = 1;
+              ++s;
+              goto ret;
+            }
+        }
+      s = s00;
+      goto ret;
+    }
+  else if (*s == '0')
     {
       nz0 = 1;
       while (*++s == '0');
@@ -205,7 +222,7 @@
 	  s = s00;
 	  goto ret;
 	}
-      s00 = s;
+      s2 = s;
       esign = 0;
       switch (c = *++s)
 	{
@@ -236,7 +253,7 @@
 	    e = 0;
 	}
       else
-	s = s00;
+	s = s2;
     }
   if (!nd)
     {
@@ -708,7 +725,10 @@
 ret:
   if (se)
     *se = (char *) s;
-  return sign ? -rv.d : rv.d;
+
+  if (nanflag)
+    return nan (NULL);
+  return (sign && (s != s00)) ? -rv.d : rv.d;
 }
 
 #ifndef NO_REENT
@@ -725,7 +745,10 @@
 	_CONST char *s00 _AND
 	char **se)
 {
-  return (float)_strtod_r (_REENT, s00, se);
+  double retval = _strtod_r (_REENT, s00, se);
+  if (isnan (retval))
+    return nanf (NULL);
+  return (float)retval;
 }
 
 #endif
Index: src/newlib/libc/string/memcmp.c
diff -u src/newlib/libc/string/memcmp.c:1.1.1.1 src/newlib/libc/string/memcmp.c:1.2
--- src/newlib/libc/string/memcmp.c:1.1.1.1	Thu Feb 17 19:39:48 2000
+++ src/newlib/libc/string/memcmp.c	Sun Mar  6 20:40:05 2005
@@ -95,8 +95,8 @@
 
       /* check m mod LBLOCKSIZE remaining characters */
 
-      s1 = (char*)a1;
-      s2 = (char*)a2;
+      s1 = (unsigned char*)a1;
+      s2 = (unsigned char*)a2;
     }
 
   while (n--)
Index: src/newlib/libc/sys/arc/syscalls.c
diff -u src/newlib/libc/sys/arc/syscalls.c:1.1 src/newlib/libc/sys/arc/syscalls.c:1.2
--- src/newlib/libc/sys/arc/syscalls.c:1.1	Fri Jan 19 01:25:13 2001
+++ src/newlib/libc/sys/arc/syscalls.c	Tue Mar 22 23:45:43 2005
@@ -15,7 +15,7 @@
 
   SYSCALL (SYS_read, rc, err, fd, buf, nbytes);
   if (err)
-    errno = err;
+    __errno_r (r) = err;
   return rc;
 }
 
@@ -27,7 +27,7 @@
 
   SYSCALL (SYS_write, rc, err, fd, buf, nbytes);
   if (err)
-    errno = err;
+    __errno_r (r) = err;
   return rc;
 }
 
@@ -48,7 +48,8 @@
 #endif
 
   SYSCALL (SYS_open, rc, err, buf, flags, mode);
-  errno = err;
+  if (err)
+    __errno_r (r) = err;
   return rc;
 }
 
@@ -59,7 +60,7 @@
 
   SYSCALL (SYS_close, rc, err, fd, 0, 0);
   if (err)
-    errno = err;
+    __errno_r (r) = err;
   return rc;
 }
 
@@ -71,7 +72,7 @@
 
   SYSCALL (SYS_lseek, rc, err, fd, offset, whence);
   if (err)
-    errno = err;
+    __errno_r (r) = err;
   return rc;
 }
 
@@ -82,7 +83,7 @@
 
   SYSCALL (SYS_fstat, rc, err, fd, buf, 0);
   if (err)
-    errno = err;
+    __errno_r (r) = err;
   return rc;
 }
 
@@ -125,6 +126,6 @@
 
   SYSCALL (SYS_kill, rc, err, pid, sig, 0);
   if (err)
-    errno = err;
+    __errno_r (r) = err;
   return rc;
 }
Index: src/newlib/libc/sys/arm/crt0.S
diff -u src/newlib/libc/sys/arm/crt0.S:1.9 src/newlib/libc/sys/arm/crt0.S:1.10
--- src/newlib/libc/sys/arm/crt0.S:1.9	Fri Nov 26 16:42:10 2004
+++ src/newlib/libc/sys/arm/crt0.S	Fri Jan  7 18:04:39 2005
@@ -1,3 +1,4 @@
+#include "newlib.h"
 #include "swi.h"
 
 /* ANSI concatenation macros.  */
@@ -10,6 +11,11 @@
 #error __USER_LABEL_PREFIX is not defined
 #endif
 
+#ifdef HAVE_INITFINI_ARRAY
+#define _init	__libc_init_array
+#define _fini	__libc_fini_array
+#endif
+
 /* .text is used instead of .section .text so it works with arm-aout too.  */
 	.text
 	.code 32
Index: src/newlib/libc/sys/arm/syscalls.c
diff -u src/newlib/libc/sys/arm/syscalls.c:1.9 src/newlib/libc/sys/arm/syscalls.c:1.10
--- src/newlib/libc/sys/arm/syscalls.c:1.9	Tue Jan  6 19:27:21 2004
+++ src/newlib/libc/sys/arm/syscalls.c	Tue Feb  8 01:33:19 2005
@@ -55,20 +55,17 @@
 
 /* following is copied from libc/stdio/local.h to check std streams */
 extern void   _EXFUN(__sinit,(struct _reent *));
-#define CHECK_INIT(fp) \
-  do                                    \
-    {                                   \
-      if ((fp)->_data == 0)             \
-        (fp)->_data = _REENT;           \
-      if (!(fp)->_data->__sdidinit)     \
-        __sinit ((fp)->_data);          \
-    }                                   \
+#define CHECK_INIT(ptr) \
+  do						\
+    {						\
+      if ((ptr) && !(ptr)->__sdidinit)		\
+	__sinit (ptr);				\
+    }						\
   while (0)
 
 /* Adjust our internal handles to stay away from std* handles.  */
 #define FILE_HANDLE_OFFSET (0x20)
 
-static int std_files_checked;
 static int monitor_stdin;
 static int monitor_stdout;
 static int monitor_stderr;
@@ -119,13 +116,8 @@
 static int
 remap_handle (int fh)
 {
-  if (!std_files_checked)
-    {
-       CHECK_INIT(stdin);
-       CHECK_INIT(stdout);
-       CHECK_INIT(stderr);
-       std_files_checked = 1;
-    }
+  CHECK_INIT(_REENT);
+
   if (fh == STDIN_FILENO)
     return monitor_stdin;
   if (fh == STDOUT_FILENO)
Index: src/newlib/libc/sys/arm/sys/param.h
diff -u /dev/null src/newlib/libc/sys/arm/sys/param.h:1.4
--- /dev/null	Thu May 12 14:25:38 2005
+++ src/newlib/libc/sys/arm/sys/param.h	Wed Feb  2 19:00:30 2005
@@ -0,0 +1,19 @@
+/* ARM configuration file; HZ is 100 rather than the default 60 */
+
+#ifndef _SYS_PARAM_H
+# define _SYS_PARAM_H
+
+# define HZ (100)
+# define NOFILE	(60)
+# define PATHSIZE (1024)
+
+#define BIG_ENDIAN      4321
+#define LITTLE_ENDIAN   1234
+
+#ifdef __ARMEB__
+#define BYTE_ORDER BIG_ENDIAN
+#else
+#define BYTE_ORDER LITTLE_ENDIAN
+#endif
+
+#endif
Index: src/newlib/libc/sys/linux/inode.c
diff -u src/newlib/libc/sys/linux/inode.c:1.9 src/newlib/libc/sys/linux/inode.c:1.10
--- src/newlib/libc/sys/linux/inode.c:1.9	Mon Aug 26 18:56:08 2002
+++ src/newlib/libc/sys/linux/inode.c	Thu Apr  7 23:40:42 2005
@@ -35,6 +35,7 @@
 _syscall2(int,chmod,const char *,path,mode_t,mode)
 _syscall3(int,chown,const char *,path,uid_t,owner,gid_t,group)
 _syscall2(int,fchmod,int,filedes,mode_t,mode)
+_syscall3(int,lchown,const char *,path,uid_t,owner,gid_t,group)
 _syscall2(int,lstat,const char *,file_name,struct stat *,buf)
 _syscall3(int,readlink,const char *,path,char *,buf,size_t,bufsiz)
 _syscall2(int,symlink,const char *,oldpath,const char *,newpath)
Index: src/newlib/libc/sys/linux/include/time.h
diff -u src/newlib/libc/sys/linux/include/time.h:1.3 src/newlib/libc/sys/linux/include/time.h:1.5
--- src/newlib/libc/sys/linux/include/time.h:1.3	Tue Sep  3 19:40:36 2002
+++ src/newlib/libc/sys/linux/include/time.h	Fri Feb 25 22:31:20 2005
@@ -84,6 +84,26 @@
 _VOID      _EXFUN(tzset,	(_VOID));
 _VOID      _EXFUN(_tzset_r,	(struct _reent *));
 
+typedef struct __tzrule_struct
+{
+  char ch;
+  int m;
+  int n;
+  int d;
+  int s;
+  time_t change;
+  long offset; /* Match type of _timezone. */
+} __tzrule_type;
+
+typedef struct __tzinfo_struct
+{
+  int __tznorth;
+  int __tzyear;
+  __tzrule_type __tzrule[2];
+} __tzinfo_type;
+
+__tzinfo_type *_EXFUN (__gettzinfo, (_VOID));
+
 /* getdate functions */
 
 #ifndef _REENT_ONLY
@@ -106,7 +126,7 @@
 int		_EXFUN(getdate_r, (const char *, struct tm *));
 
 /* defines for the opengroup specifications Derived from Issue 1 of the SVID.  */
-extern __IMPORT time_t _timezone;
+extern __IMPORT long _timezone;
 extern __IMPORT int _daylight;
 extern __IMPORT char *_tzname[2];
 
Index: src/newlib/libc/sys/linux/sys/string.h
diff -u /dev/null src/newlib/libc/sys/linux/sys/string.h:1.1
--- /dev/null	Thu May 12 14:25:57 2005
+++ src/newlib/libc/sys/linux/sys/string.h	Mon Jan 24 18:46:09 2005
@@ -0,0 +1,8 @@
+#ifndef _SYS_STRING_H
+#define _SYS_STRING_H
+
+#ifndef __STRICT_ANSI__
+char    *_EXFUN(strsignal, (int __signo));
+#endif
+
+#endif /* _SYS_STRING_H */
Index: src/newlib/libc/sys/rtems/include/inttypes.h
diff -u /dev/null src/newlib/libc/sys/rtems/include/inttypes.h:1.1
--- /dev/null	Thu May 12 14:25:58 2005
+++ src/newlib/libc/sys/rtems/include/inttypes.h	Sun Mar  6 20:51:38 2005
@@ -0,0 +1,288 @@
+/*
+ * Copyright (c) 2004, 2005 by
+ * Ralf Corsepius, Ulm/Germany. All rights reserved.
+ *
+ * Permission to use, copy, modify, and distribute this software
+ * is freely granted, provided that this notice is preserved.
+ */
+
+/**
+ *  @file  inttypes.h
+ */
+
+#ifndef _INTTYPES_H
+#define _INTTYPES_H
+
+#include <stdint.h>
+
+#define __STRINGIFY(a) #a
+
+/* 8-bit types */
+#define __PRI8(x) __STRINGIFY(x)
+#define __SCN8(x) __STRINGIFY(hh##x)
+
+
+#define PRId8		__PRI8(d)
+#define PRIi8		__PRI8(i)
+#define PRIo8		__PRI8(o)
+#define PRIu8		__PRI8(u)
+#define PRIx8		__PRI8(x)
+#define PRIX8		__PRI8(X)
+
+#define SCNd8		__SCN8(d)
+#define SCNi8		__SCN8(i)
+#define SCNo8		__SCN8(o)
+#define SCNu8		__SCN8(u)
+#define SCNx8		__SCN8(x)
+
+
+#define PRIdLEAST8	__PRI8(d)
+#define PRIiLEAST8	__PRI8(i)
+#define PRIoLEAST8	__PRI8(o)
+#define PRIuLEAST8	__PRI8(u)
+#define PRIxLEAST8	__PRI8(x)
+#define PRIXLEAST8	__PRI8(X)
+
+#define SCNdLEAST8	__SCN8(d)
+#define SCNiLEAST8	__SCN8(i)
+#define SCNoLEAST8	__SCN8(o)
+#define SCNuLEAST8	__SCN8(u)
+#define SCNxLEAST8	__SCN8(x)
+
+
+#define PRIdFAST8	__PRI8(d)
+#define PRIiFAST8	__PRI8(i)
+#define PRIoFAST8	__PRI8(o)
+#define PRIuFAST8	__PRI8(u)
+#define PRIxFAST8	__PRI8(x)
+#define PRIXFAST8	__PRI8(X)
+
+#define SCNdFAST8	__SCN8(d)
+#define SCNiFAST8	__SCN8(i)
+#define SCNoFAST8	__SCN8(o)
+#define SCNuFAST8	__SCN8(u)
+#define SCNxFAST8	__SCN8(x)
+
+/* 16-bit types */
+#define __PRI16(x) __STRINGIFY(x)
+#define __SCN16(x) __STRINGIFY(h##x)
+
+
+#define PRId16		__PRI16(d)
+#define PRIi16		__PRI16(i)
+#define PRIo16		__PRI16(o)
+#define PRIu16		__PRI16(u)
+#define PRIx16		__PRI16(x)
+#define PRIX16		__PRI16(X)
+
+#define SCNd16		__SCN16(d)
+#define SCNi16		__SCN16(i)
+#define SCNo16		__SCN16(o)
+#define SCNu16		__SCN16(u)
+#define SCNx16		__SCN16(x)
+
+
+#define PRIdLEAST16	__PRI16(d)
+#define PRIiLEAST16	__PRI16(i)
+#define PRIoLEAST16	__PRI16(o)
+#define PRIuLEAST16	__PRI16(u)
+#define PRIxLEAST16	__PRI16(x)
+#define PRIXLEAST16	__PRI16(X)
+
+#define SCNdLEAST16	__SCN16(d)
+#define SCNiLEAST16	__SCN16(i)
+#define SCNoLEAST16	__SCN16(o)
+#define SCNuLEAST16	__SCN16(u)
+#define SCNxLEAST16	__SCN16(x)
+
+
+#define PRIdFAST16	__PRI16(d)
+#define PRIiFAST16	__PRI16(i)
+#define PRIoFAST16	__PRI16(o)
+#define PRIuFAST16	__PRI16(u)
+#define PRIxFAST16	__PRI16(x)
+#define PRIXFAST16	__PRI16(X)
+
+#define SCNdFAST16	__SCN16(d)
+#define SCNiFAST16	__SCN16(i)
+#define SCNoFAST16	__SCN16(o)
+#define SCNuFAST16	__SCN16(u)
+#define SCNxFAST16	__SCN16(x)
+
+/* 32-bit types */
+#if defined(__have_long32)
+#define __PRI32(x) __STRINGIFY(l##x)
+#define __SCN32(x) __STRINGIFY(l##x)
+#else
+#define __PRI32(x) __STRINGIFY(x)
+#define __SCN32(x) __STRINGIFY(x)
+#endif
+
+#define PRId32		__PRI32(d)
+#define PRIi32		__PRI32(i)
+#define PRIo32		__PRI32(o)
+#define PRIu32		__PRI32(u)
+#define PRIx32		__PRI32(x)
+#define PRIX32		__PRI32(X)
+
+#define SCNd32		__SCN32(d)
+#define SCNi32		__SCN32(i)
+#define SCNo32		__SCN32(o)
+#define SCNu32		__SCN32(u)
+#define SCNx32		__SCN32(x)
+
+
+#define PRIdLEAST32	__PRI32(d)
+#define PRIiLEAST32	__PRI32(i)
+#define PRIoLEAST32	__PRI32(o)
+#define PRIuLEAST32	__PRI32(u)
+#define PRIxLEAST32	__PRI32(x)
+#define PRIXLEAST32	__PRI32(X)
+
+#define SCNdLEAST32	__SCN32(d)
+#define SCNiLEAST32	__SCN32(i)
+#define SCNoLEAST32	__SCN32(o)
+#define SCNuLEAST32	__SCN32(u)
+#define SCNxLEAST32	__SCN32(x)
+
+
+#define PRIdFAST32	__PRI32(d)
+#define PRIiFAST32	__PRI32(i)
+#define PRIoFAST32	__PRI32(o)
+#define PRIuFAST32	__PRI32(u)
+#define PRIxFAST32	__PRI32(x)
+#define PRIXFAST32	__PRI32(X)
+
+#define SCNdFAST32	__SCN32(d)
+#define SCNiFAST32	__SCN32(i)
+#define SCNoFAST32	__SCN32(o)
+#define SCNuFAST32	__SCN32(u)
+#define SCNxFAST32	__SCN32(x)
+
+
+/* 64-bit types */
+#if defined(__have_longlong64)
+#define __PRI64(x) __STRINGIFY(ll##x)
+#define __SCN64(x) __STRINGIFY(ll##x)
+#elif defined(__have_long64)
+#define __PRI64(x) __STRINGIFY(l##x)
+#define __SCN64(x) __STRINGIFY(l##x)
+#else
+#define __PRI64(x) __STRINGIFY(x)
+#define __SCN64(x) __STRINGIFY(x)
+#endif
+
+#define PRId64		__PRI64(d)
+#define PRIi64		__PRI64(i)
+#define PRIo64		__PRI64(o)
+#define PRIu64		__PRI64(u)
+#define PRIx64		__PRI64(x)
+#define PRIX64		__PRI64(X)
+
+#define SCNd64		__SCN64(d)
+#define SCNi64		__SCN64(i)
+#define SCNo64		__SCN64(o)
+#define SCNu64		__SCN64(u)
+#define SCNx64		__SCN64(x)
+
+#if __int64_t_defined
+#define PRIdLEAST64	__PRI64(d)
+#define PRIiLEAST64	__PRI64(i)
+#define PRIoLEAST64	__PRI64(o)
+#define PRIuLEAST64	__PRI64(u)
+#define PRIxLEAST64	__PRI64(x)
+#define PRIXLEAST64	__PRI64(X)
+
+#define SCNdLEAST64	__SCN64(d)
+#define SCNiLEAST64	__SCN64(i)
+#define SCNoLEAST64	__SCN64(o)
+#define SCNuLEAST64	__SCN64(u)
+#define SCNxLEAST64	__SCN64(x)
+
+
+#define PRIdFAST64	__PRI64(d)
+#define PRIiFAST64	__PRI64(i)
+#define PRIoFAST64	__PRI64(o)
+#define PRIuFAST64	__PRI64(u)
+#define PRIxFAST64	__PRI64(x)
+#define PRIXFAST64	__PRI64(X)
+
+#define SCNdFAST64	__SCN64(d)
+#define SCNiFAST64	__SCN64(i)
+#define SCNoFAST64	__SCN64(o)
+#define SCNuFAST64	__SCN64(u)
+#define SCNxFAST64	__SCN64(x)
+#endif
+
+/* max-bit types */
+#if defined(__have_longlong64)
+#define __PRIMAX(x) __STRINGIFY(ll##x)
+#define __SCNMAX(x) __STRINGIFY(ll##x)
+#elif defined(__have_long64)
+#define __PRIMAX(x) __STRINGIFY(l##x)
+#define __SCNMAX(x) __STRINGIFY(l##x)
+#else
+#define __PRIMAX(x) __STRINGIFY(x)
+#define __SCNMAX(x) __STRINGIFY(x)
+#endif
+
+#define PRIdMAX		__PRIMAX(d)
+#define PRIiMAX		__PRIMAX(i)
+#define PRIoMAX		__PRIMAX(o)
+#define PRIuMAX		__PRIMAX(u)
+#define PRIxMAX		__PRIMAX(x)
+#define PRIXMAX		__PRIMAX(X)
+
+#define SCNdMAX		__SCNMAX(d)
+#define SCNiMAX		__SCNMAX(i)
+#define SCNoMAX		__SCNMAX(o)
+#define SCNuMAX		__SCNMAX(u)
+#define SCNxMAX		__SCNMAX(x)
+
+/* ptr types */
+#if defined(__have_longlong64)
+#define __PRIPTR(x) __STRINGIFY(ll##x)
+#define __SCNPTR(x) __STRINGIFY(ll##x)
+#elif defined(__have_long64)
+#define __PRIPTR(x) __STRINGIFY(l##x)
+#define __SCNPTR(x) __STRINGIFY(l##x)
+#else
+#define __PRIPTR(x) __STRINGIFY(x)
+#define __SCNPTR(x) __STRINGIFY(x)
+#endif
+
+#define PRIdPTR		__PRIPTR(d)
+#define PRIiPTR		__PRIPTR(i)
+#define PRIoPTR		__PRIPTR(o)
+#define PRIuPTR		__PRIPTR(u)
+#define PRIxPTR		__PRIPTR(x)
+#define PRIXPTR		__PRIPTR(X)
+
+#define SCNdPTR		__SCNPTR(d)
+#define SCNiPTR		__SCNPTR(i)
+#define SCNoPTR		__SCNPTR(o)
+#define SCNuPTR		__SCNPTR(u)
+#define SCNxPTR		__SCNPTR(x)
+
+
+typedef struct {
+  intmax_t	quot;
+  intmax_t	rem;
+} imaxdiv_t;
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+extern intmax_t  imaxabs(intmax_t j);
+extern imaxdiv_t imaxdiv(intmax_t numer, intmax_t denomer);
+extern intmax_t  strtoimax(const char *__restrict, char **__restrict, int);
+extern uintmax_t strtoumax(const char *__restrict, char **__restrict, int);
+extern intmax_t  wcstoimax(const wchar_t *__restrict, wchar_t **__restrict, int);
+extern uintmax_t wcstoumax(const wchar_t *__restrict, wchar_t **__restrict, int);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
Index: src/newlib/libc/sys/rtems/include/stdint.h
diff -u /dev/null src/newlib/libc/sys/rtems/include/stdint.h:1.1
--- /dev/null	Thu May 12 14:25:59 2005
+++ src/newlib/libc/sys/rtems/include/stdint.h	Sun Mar  6 20:51:38 2005
@@ -0,0 +1,282 @@
+/*
+ * Copyright (c) 2004, 2005 by
+ * Ralf Corsepius, Ulm/Germany. All rights reserved.
+ *
+ * Permission to use, copy, modify, and distribute this software
+ * is freely granted, provided that this notice is preserved.
+ */
+
+/*
+ * @todo - Add fast<N>_t types.
+ * @todo - Add support for wint_t types.
+ */
+
+#ifndef _STDINT_H
+#define _STDINT_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#if defined(__GNUC__) && (__GNUC__ >= 3 ) \
+  && defined(__GNUC_MINOR__) && (__GNUC_MINOR__ > 2 ) 
+#define __EXP(x) __##x##__
+#else
+#define __EXP(x) x
+#include <limits.h>
+#endif
+
+#if __EXP(SCHAR_MAX) == 0x7f
+typedef signed char int8_t ;
+typedef unsigned char uint8_t ;
+#define __int8_t_defined 1
+#endif
+
+#if __int8_t_defined
+typedef signed char int_least8_t;
+typedef unsigned char uint_least8_t;
+#define __int_least8_t_defined 1
+#endif
+
+#if __EXP(SHRT_MAX) == 0x7fff
+typedef signed short int16_t;
+typedef unsigned short uint16_t;
+#define __int16_t_defined 1
+#elif __EXP(INT_MAX) == 0x7fff
+typedef signed int int16_t;
+typedef unsigned int uint16_t;
+#define __int16_t_defined 1
+#elif __EXP(SCHAR_MAX) == 0x7fff
+typedef signed char int16_t;
+typedef unsigned char uint16_t;
+#define __int16_t_defined 1
+#endif
+
+#if __int16_t_defined
+typedef int16_t   	int_least16_t;
+typedef uint16_t 	uint_least16_t;
+#define __int_least16_t_defined 1
+
+#ifndef __int_least8_t_defined
+typedef int16_t	   	int_least8_t;
+typedef uint16_t  	uint_least8_t;
+#define __int_least8_t_defined 1
+#endif
+#endif
+
+#if __EXP(INT_MAX) == 0x7fffffffL
+typedef signed int int32_t;
+typedef unsigned int uint32_t;
+#define __int32_t_defined 1
+#elif __EXP(LONG_MAX) == 0x7fffffffL
+typedef signed long int32_t;
+typedef unsigned long uint32_t;
+#define __int32_t_defined 1
+#define __have_long32 1
+#elif __EXP(SHRT_MAX) == 0x7fffffffL
+typedef signed short int32_t;
+typedef unsigned short uint32_t;
+#define __int32_t_defined 1
+#elif __EXP(SCHAR_MAX) == 0x7fffffffL
+typedef signed char int32_t;
+typedef unsigned char uint32_t;
+#define __int32_t_defined 1
+#endif
+
+#if __int32_t_defined
+typedef int32_t   	int_least32_t;
+typedef uint32_t 	uint_least32_t;
+#define __int_least32_t_defined 1
+
+#ifndef __int_least8_t_defined
+typedef int32_t	   	int_least8_t;
+typedef uint32_t  	uint_least8_t;
+#define __int_least8_t_defined 1
+#endif
+
+#ifndef __int_least16_t_defined
+typedef int32_t	   	int_least16_t;
+typedef uint32_t  	uint_least16_t;
+#define __int_least16_t_defined 1
+#endif
+#endif
+
+#if __EXP(LONG_MAX) > 0x7fffffff
+typedef signed long int64_t;
+typedef unsigned long uint64_t;
+#define __int64_t_defined 1
+#define __have_long64 1
+#elif  defined(__LONG_LONG_MAX__) && (__LONG_LONG_MAX__ > 0x7fffffff)
+typedef signed long long int64_t;
+typedef unsigned long long uint64_t;
+#define __int64_t_defined 1
+#define __have_longlong64 1
+#elif  defined(LLONG_MAX) && (LLONG_MAX > 0x7fffffff)
+typedef signed long long int64_t;
+typedef unsigned long long uint64_t;
+#define __int64_t_defined 1
+#define __have_longlong64 1
+#elif  __EXP(INT_MAX) > 0x7fffffff
+typedef signed int int64_t;
+typedef unsigned int uint64_t;
+#define __int64_t_defined 1
+#endif
+
+#if __int64_t_defined
+typedef int64_t   	int_least64_t;
+typedef uint64_t 	uint_least64_t;
+#define __int_least64_t_defined 1
+
+#ifndef __int_least8_t_defined
+typedef int64_t	   	int_least8_t;
+typedef uint64_t  	uint_least8_t;
+#define __int_least8_t_defined 1
+#endif
+
+#ifndef __int_least16_t_defined
+typedef int64_t	   	int_least16_t;
+typedef uint64_t  	uint_least16_t;
+#define __int_least16_t_defined 1
+#endif
+
+#ifndef __int_least32_t_defined
+typedef int64_t	   	int_least32_t;
+typedef uint64_t  	uint_least32_t;
+#define __int_least32_t_defined 1
+#endif
+#endif
+
+#if __have_longlong64
+typedef signed long long intmax_t;
+typedef unsigned long long uintmax_t;
+#else
+typedef signed long intmax_t;
+typedef unsigned long uintmax_t;
+#endif
+
+/*
+ * GCC doesn't provide an propriate macro for [u]intptr_t
+ * For now, use __PTRDIFF_TYPE__
+ */
+#if defined(__PTRDIFF_TYPE__)
+typedef signed __PTRDIFF_TYPE__ intptr_t;
+typedef unsigned __PTRDIFF_TYPE__ uintptr_t;
+#else
+/*
+ * Fallback to hardcoded values, 
+ * should be valid on cpu's with 32bit int/32bit void*
+ */
+typedef signed long intptr_t;
+typedef unsigned long uintptr_t;
+#endif
+
+/* Limits of Specified-Width Integer Types */
+
+#if __int8_t_defined
+#define INT8_MIN 	-128
+#define INT8_MAX 	 127
+#define UINT8_MAX 	 255
+#endif
+
+#if __int_least8_t_defined
+#define INTLEAST8_MIN 	-128
+#define INTLEAST8_MAX 	 127
+#define UINTLEAST8_MAX 	 255
+#else
+#error required type int_least8_t missing
+#endif
+
+#if __int16_t_defined
+#define INT16_MIN 	-32768
+#define INT16_MAX 	 32767
+#define UINT16_MAX 	 65535
+#endif
+
+#if __int_least16_t_defined
+#define INTLEAST16_MIN 	-32768
+#define INTLEAST16_MAX 	 32767
+#define UINTLEAST16_MAX  65535
+#else
+#error required type int_least16_t missing
+#endif
+
+#if __int32_t_defined
+#define INT32_MIN 	-2147483648
+#define INT32_MAX 	 2147483647
+#define UINT32_MAX       4294967295
+#endif
+
+#if __int_least32_t_defined
+#define INTLEAST32_MIN 	-2147483648
+#define INTLEAST32_MAX 	 2147483647
+#define UINTLEAST32_MAX  4294967295
+#else
+#error required type int_least32_t missing
+#endif
+
+#if __int64_t_defined
+#define INT64_MIN 	-9223372036854775808
+#define INT64_MAX 	 9223372036854775807
+#define UINT64_MAX 	18446744073709551615
+#endif
+
+#if __int_least64_t_defined
+#define INTLEAST64_MIN 	-9223372036854775808
+#define INTLEAST64_MAX 	 9223372036854775807
+#define UINTLEAST64_MAX 18446744073709551615
+#endif
+
+/* This must match size_t in stddef.h, currently long unsigned int */
+#define SIZE_MIN (-__EXP(LONG_MAX) - 1L)
+#define SIZE_MAX __EXP(LONG_MAX)
+
+/* This must match sig_atomic_t in <signal.h> (currently int) */
+#define SIG_ATOMIC_MIN (-__EXP(INT_MAX) - 1)
+#define SIG_ATOMIC_MAX __EXP(INT_MAX)
+
+/* This must match ptrdiff_t  in <stddef.h> (currently long int) */
+#define PTRDIFF_MIN (-__EXP(LONG_MAX) - 1L)
+#define PTHDIFF_MAX __EXT(LONG_MAX)
+
+#undef __EXP
+
+/** Macros for minimum-width integer constant expressions */
+#define INT8_C(x)	x
+#define UINT8_C(x)	x##U
+
+#define INT16_C(x)	x
+#define UINT16_C(x)	x##U
+
+#if __have_long32
+#define INT32_C(x)	x##L
+#define UINT32_C(x)	x##UL
+#else
+#define INT32_C(x)	x
+#define UINT32_C(x)	x##U
+#endif
+
+#if __int64_t_defined
+#if __have_longlong64
+#define INT64_C(x)	x##LL
+#define UINT64_C(x)	x##ULL
+#else
+#define INT64_C(x)	x##L
+#define UINT64_C(x)	x##UL
+#endif
+#endif
+
+/** Macros for greatest-width integer constant expression */
+#if __have_longlong64
+#define INTMAX_C(x)	x##LL
+#define UINTMAX_C(x)	x##ULL
+#else
+#define INTMAX_C(x)	x##L
+#define UINTMAX_C(x)	x##UL
+#endif
+
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _STDINT_H */
Index: src/newlib/libc/time/Makefile.am
diff -u src/newlib/libc/time/Makefile.am:1.4 src/newlib/libc/time/Makefile.am:1.5
--- src/newlib/libc/time/Makefile.am:1.4	Wed Apr 17 21:23:31 2002
+++ src/newlib/libc/time/Makefile.am	Wed Feb 23 19:08:57 2005
@@ -11,6 +11,7 @@
 	ctime.c		\
 	ctime_r.c	\
 	difftime.c	\
+	gettzinfo.c	\
 	gmtime.c	\
 	gmtime_r.c	\
 	lcltime.c	\
Index: src/newlib/libc/time/gettzinfo.c
diff -u /dev/null src/newlib/libc/time/gettzinfo.c:1.2
--- /dev/null	Thu May 12 14:26:03 2005
+++ src/newlib/libc/time/gettzinfo.c	Fri Feb 25 22:31:21 2005
@@ -0,0 +1,15 @@
+#include <sys/types.h>
+#include <local.h>
+
+/* Shared timezone information for libc/time functions.  */
+static __tzinfo_type tzinfo = {1, 0,
+    { {'J', 0, 0, 0, 0, (time_t)0, 0L },
+      {'J', 0, 0, 0, 0, (time_t)0, 0L } 
+    } 
+};
+
+__tzinfo_type *
+__gettzinfo (void)
+{
+  return &tzinfo;
+}
Index: src/newlib/libc/time/local.h
diff -u src/newlib/libc/time/local.h:1.1 src/newlib/libc/time/local.h:1.2
--- src/newlib/libc/time/local.h:1.1	Wed Apr 17 21:23:31 2002
+++ src/newlib/libc/time/local.h	Wed Feb 23 19:08:58 2005
@@ -19,24 +19,6 @@
 
 #define isleap(y) ((((y) % 4) == 0 && ((y) % 100) != 0) || ((y) % 400) == 0)
 
-extern time_t __tzstart_std;
-extern time_t __tzstart_dst;
-extern int __tznorth;
-extern int __tzyear;
-
-typedef struct __tzrule_struct
-{
-  char ch;
-  int m;
-  int n;
-  int d;
-  int s;
-  time_t change;
-  int offset;
-} __tzrule_type;
-
-extern __tzrule_type __tzrule[2];
-
 struct tm * _EXFUN (_mktm_r, (_CONST time_t *, struct tm *, int __is_gmtime));
 int         _EXFUN (__tzcalc_limits, (int __year));
 
Index: src/newlib/libc/time/mktime.c
diff -u src/newlib/libc/time/mktime.c:1.3 src/newlib/libc/time/mktime.c:1.5
--- src/newlib/libc/time/mktime.c:1.3	Wed Apr 17 21:23:31 2002
+++ src/newlib/libc/time/mktime.c	Fri Feb 25 22:31:21 2005
@@ -158,6 +158,7 @@
   time_t tim = 0;
   long days = 0;
   int year, isdst;
+  __tzinfo_type *tz = __gettzinfo ();
 
   /* validate structure */
   validate_structure (tim_p);
@@ -206,27 +207,34 @@
   if (_daylight)
     {
       int y = tim_p->tm_year + YEAR_BASE;
-      if (y == __tzyear || __tzcalc_limits (y))
+      if (y == tz->__tzyear || __tzcalc_limits (y))
 	{
 	  /* calculate start of dst in dst local time and 
 	     start of std in both std local time and dst local time */
-          time_t startdst_dst = __tzrule[0].change - __tzrule[1].offset;
-	  time_t startstd_dst = __tzrule[1].change - __tzrule[1].offset;
-	  time_t startstd_std = __tzrule[1].change - __tzrule[0].offset;
+          time_t startdst_dst = tz->__tzrule[0].change
+	    - (time_t) tz->__tzrule[1].offset;
+	  time_t startstd_dst = tz->__tzrule[1].change
+	    - (time_t) tz->__tzrule[1].offset;
+	  time_t startstd_std = tz->__tzrule[1].change
+	    - (time_t) tz->__tzrule[0].offset;
 	  /* if the time is in the overlap between dst and std local times */
 	  if (tim >= startstd_std && tim < startstd_dst)
 	    ; /* we let user decide or leave as -1 */
           else
 	    {
-	      isdst = (__tznorth
+	      isdst = (tz->__tznorth
 		       ? (tim >= startdst_dst && tim < startstd_std)
 		       : (tim >= startdst_dst || tim < startstd_std));
 	      /* if user committed and was wrong, perform correction */
 	      if ((isdst ^ tim_p->tm_isdst) == 1)
 		{
 		  /* we either subtract or add the difference between
-		     time zone offsets, depending on which way the user got it wrong */
-		  int diff = __tzrule[0].offset - __tzrule[1].offset;
+		     time zone offsets, depending on which way the user got it
+		     wrong. The diff is typically one hour, or 3600 seconds,
+		     and should fit in a 16-bit int, even though offset
+		     is a long to accomodate 12 hours. */
+		  int diff = (int) (tz->__tzrule[0].offset
+				    - tz->__tzrule[1].offset);
 		  if (!isdst)
 		    diff = -diff;
 		  tim_p->tm_sec += diff;
@@ -239,9 +247,9 @@
 
   /* add appropriate offset to put time in gmt format */
   if (isdst == 1)
-    tim += __tzrule[1].offset;
+    tim += (time_t) tz->__tzrule[1].offset;
   else /* otherwise assume std time */
-    tim += __tzrule[0].offset;
+    tim += (time_t) tz->__tzrule[0].offset;
 
   /* reset isdst flag to what we have calculated */
   tim_p->tm_isdst = isdst;
